/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package or.ca.webduino;

import java.io.IOException;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.ca.javafirmata.Firmata;

/**
 *
 * @author caschoff
 */
public class Controller extends HttpServlet {

    private static Firmata f;
    private static boolean[] digitalPins = new boolean[14];

    static {
        try {
            f = new Firmata("/dev/tty.usbmodem1d11", 57600);

            for (int i = 8; i < 14; i++) {
                f.pinMode(i, Firmata.OUTPUT);
            }

            for (int i = 0; i < 14; i++) {
                digitalPins[i] = false;
            }
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {

        request.setAttribute("a0", f.analogRead(0));
        request.setAttribute("a1", f.analogRead(1));

        for (int i = 8; i < 14; i++) {
            digitalPins[i] = request.getParameter("d" + i) != null;
        }
        try {
            for (int i = 8; i < 14; i++) {
                if (digitalPins[i]) {
                    f.digitalWrite(i, Firmata.HIGH);
                } else {
                    f.digitalWrite(i, Firmata.LOW);
                }
            }
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        request.setAttribute("digitalPins", digitalPins);

        RequestDispatcher rd = request.getRequestDispatcher("arduino.jsp");
        rd.forward(request, response);
    }

    @Override
    public void destroy() {
        f = null;
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>
}
